[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.2 and 1.95

version 1.2, 2021/10/05 01:39:05 version 1.95, 2021/12/21 02:16:47
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
         # no bsort for now  set +o monitor
         sed -n "$1" /var/run/dmesg.boot  export PATH=/usr/bin:/bin:/usr/sbin:/sbin
   
   CFILE=SHA256.sig
   DESTDIR=${DESTDIR:-}
   FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
   
   VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
   HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   DOWNLOAD=true
   INSTALL=true
   LOCALSRC=
   
   tmpdir() {
           local _i=1 _dir
   
           # If we're not in the installer,
           # we have mktemp and a more hostile environment.
           if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
           echo "$_dir"
 }  }
   
   fetch() {
           local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
   
           # If we're not in the installer,
           # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
           (
           if [ -x /usr/bin/su ]; then
                   exec /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
           else
                   exec /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
           fi
           ) & _pid=$!
           set +o monitor
   
           trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
   
           SECONDS=0
           _last=0
           while kill -0 -"$_pid" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$_pid"
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$_pid"
           _exit=$?
           set -o errexit
   
           trap "" EXIT INT QUIT ABRT TERM
   
           if [ "$_exit" -ne 0 ]; then
                   rm -f "$_dst"
                   echo "Cannot fetch $_src$_error" >&2
                   return 1
           fi
   }
   
   verify() {
           # On the installer we don't get sha256 -C, so fake it.
           if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
           fi
   }
   
   devices_needing_firmware() {
           local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
           # When we're not in the installer, the dmesg.boot can
           # contain multiple boots, so only look in the last one
           _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
               grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
   
           grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   [ "$_d" = "$_last" ] && continue
                   [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                   [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
   
                   if [[ $_dmesgtail = *$_m* ]]; then
                           echo "$_d"
                           _last="$_d"
                   fi
               done
   }
   
   firmware_filename() {
           local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
   }
   
   firmware_devicename() {
           local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
   }
   
 installed_firmware() {  installed_firmware() {
         for fw in ${PKGDIR}/$1-firmware*; do          set +o noglob
           for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                 [ -e "$fw" ] || continue                  [ -e "$fw" ] || continue
                 echo ${fw##*/}                  echo "${fw##*/}"
         done          done
           set -o noglob
 }  }
   
 set -A _KERNV -- $( scan_dmesg '/^OpenBSD \([1-9][0-9]*\.[0-9]\)\([^ ]*\) .*/ { s//\1 \2/p; q; }' )  add_firmware () {
 VNAME=${_KERNV[0]}          local _f="${1##*/}"
 OSDIR=$VNAME          local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
 if ((${#_KERNV[*]} > 1)) && [ "$_KERNV[1]" = "-current" -o "$_KERNV[1]" = "-beta" ]; then          ftp -D "Install" -Vmo- "file:${1}" |
         OSDIR=snapshots                  tar -s ",^\+,${_pkgdir}/+," \
 fi                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
 FWURL=http://firmware.openbsd.org/firmware/${OSDIR}          # TODO: Should we mark these so real fw_update can -Drepair?
 PKGDIR=${DESTDIR}/var/db/pkg          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 PATTERNS="file:${0%/*}/firmware_patterns"  /^@comment pkgpath/ -1a
   @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
   }
   
 drivers=$(  delete_firmware() {
         last=''          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
         ftp -D "Detecting" -Vmo- $PATTERNS |  
         while read d m; do          # TODO: Check hash for files before deleting
                 [ "$last" = "$d" ] && continue          echo "Uninstalling $_pkg"
                 [ "$m" ] || m="^$d[0-9][0-9]* at "          _cwd="${_pkgdir}/$_pkg"
                 grep -q "$m" /var/run/dmesg.boot || continue  
                 echo $d          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
                 last=$d  
           while read -r c g; do
                   case $c in
                   @cwd) _cwd="${DESTDIR}$g"
                     ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
           # We specifically rm -f here because not removing files/dirs
           # is probably not worth failing over.
           for _r in "${_remove[@]}" ; do
                   if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
                           # without rmdir on the install media.
                           set +o noglob
                           [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                           set -o noglob
                   else
                           rm -f "$_r"
                   fi
         done          done
 )  }
   
 if [ -z "$drivers" ]; then  usage() {
         echo "No devices found which need firmware files to be downloaded." >&2          echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
         exit 0          exit 2
 fi  }
   
 tmpdir=${DESTDIR}/tmp/fw_update  OPT_D=
 [ -e "$tmpdir" ] && rm -rf "$tmpdir"  OPT_L=
 mkdir -p "$tmpdir"  while getopts DL name
 cd "$tmpdir"  do
          case "$name" in
          D) OPT_D=true ;;
          L) OPT_L=true ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
 # TODO: Drop privs during fetch and verify  [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
 ftp -D Get -Vm "$FWURL/SHA256.sig"  
   
 # Probably should bundle the firmware sigfile on the installer,  if [ "$OPT_D" ]; then
 # although we can just get it from the recently installed system.          # "Download only" means local dir and don't install
 if [ "$DESTDIR" ]; then          INSTALL=false
         sigfile=$( sed -n '/^untrusted comment: verify with \(.*\)$/ { s//\1/p; q; }' SHA256.sig )          LOCALSRC=.
         if [ ! -e "/etc/signify/$sigfile" ] \  elif [ "$OPT_L" ]; then
           && [ -e "${DESTDIR}/etc/signify/$sigfile" ]; then          # "Local" means don't download, install from local dir
                 cp -a "${DESTDIR}/etc/signify/$sigfile" "/etc/signify/$sigfile"          DOWNLOAD=false
         fi          LOCALSRC=.
   else
           LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
 fi  fi
   
 signify -Ve -x SHA256.sig -m - < SHA256.sig > SHA256  CFILE="$LOCALSRC/$CFILE"
   
 for d in $drivers; do  if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then
         firmware=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" SHA256 )          echo "need root privileges" >&2
         installed=$( installed_firmware $d )          exit 1
   fi
   
         for i in $installed; do  set -A devices -- "$@"
                 if [ "$firmware" = "$i.tgz" ]; then  
                         echo "Firmware for $d already installed ($installed)"  
                         continue 2  
                 fi  
         done  
   
         mkdir $d  if [ ! "${devices[*]:-}" ]; then
           echo -n "Detecting firmware ..."
           set -A devices -- $( devices_needing_firmware )
           [ "${devices[*]:-}" ] && echo " found." || echo " done."
   fi
   
         # TODO: Drop privs during fetch and verify  [ "${devices[*]:-}" ] || exit
         ftp -D "Get/Verify" -Vmo- "$FWURL/$firmware" | sha256 -bph "$d/h" > "$firmware"  
         fgrep -qx "SHA256 ($firmware) = $(<$d/h)" SHA256  
   
         # TODO: Check hash for files before deleting  if "$DOWNLOAD"; then
         if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then          fetch "$CFILE"
                 echo "Uninstalling $installed"          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                 cwd=${PKGDIR}/$installed              echo "Signature check of SHA256.sig failed" >&2 && exit 1
   fi
   
                 remove="${cwd}/+CONTENTS ${cwd}"  for f in "${devices[@]}"; do
           d="$( firmware_devicename "$f" )"
   
                 while read c g; do          if [ "$f" = "$d" ]; then
                         case $c in                  f=$( firmware_filename "$d" || true )
                         @cwd) cwd=$g                  [ "$f" ] || continue
                           ;;                  f="$LOCALSRC/$f"
                         @*) continue          elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                           ;;                  echo "Cannot download local file $f" >&2
                         *)  remove="$cwd/$c $remove"                  exit 2
                           ;;          fi
                         esac  
                 done < "${PKGDIR}/$installed/+CONTENTS"  
   
                 for r in $remove ; do          set -A installed -- $( installed_firmware "$d" )
                         if [ -d "$r" ]; then  
                                 # Try hard not to actually remove recursively          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                                 # without rmdir on the install media.                  for i in "${installed[@]}"; do
                                 [ "$r/*" = $( echo "$r"/* ) ] && rm -rf "$r"                          if [ "${f##*/}" = "$i.tgz" ]; then
                         else                                  echo "$i already installed"
                                 rm -f "$r"                                  continue 2
                         fi                          fi
                 done                  done
         fi          fi
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add          if [ -e "$f" ]; then
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall                  if "$DOWNLOAD"; then
         echo "Installing $firmware"                          echo "Verify existing ${f##*/}"
         tar -zxphf "$firmware" -C /etc "firmware/*"                          verify "$f" || continue
         mkdir -p ${PKGDIR}/${firmware%.tgz}/                  # else assume it was verified when downloaded
         tar -zxphf "$firmware" -C "${PKGDIR}/${firmware%.tgz}" "+*"                  fi
     ed -s "${PKGDIR}/${firmware%.tgz}/+CONTENTS" <<EOL          elif "$DOWNLOAD"; then
 /^@comment pkgpath/ -1a                  fetch  "$f" || continue
 @option manual-installation                  verify "$f" || continue
 @option firmware          elif "$INSTALL"; then
 @comment install-script                  echo "Cannot install ${f##*/}, not found" >&2
 .                  continue
 w          fi
 EOL  
           "$INSTALL" || continue
   
           if [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           delete_firmware "$i"
                   done
           fi
   
           add_firmware "$f"
 done  done
   

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.95

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>